RevEx.ReviewExtractor = function(document)
{
	/******************************************************/
	/************************ Info ************************/
	/******************************************************/

	this.reviewExtracted = false;
	this.showingContent = false;
	this.document = document;
	this.originalBody = this.document.body;
	this.contentBody = null;

	this.obtainAlgorithm = function()
	{
		return new RevEx.revex.RevEx();			
	}

	/******************************************************/
	/****************** Extract Content ******************/
	/******************************************************/
	this.extractContentCallback = null;

	this.extractContent = function(initialURL, callback)
	{
		this.extractContentCallback = callback;

		if (this.reviewExtracted)
		{
			this.extractContentCallback();
			return;
		}

		this.extractWebContent(initialURL);
	}
	this.extractWebContent = function(initialURL)
	{
		var algorithm = this.obtainAlgorithm();

		algorithm.process(initialURL, this.document, this.extractedWebContent.bind(this));
	}
	this.extractedWebContent = function(contentBody, contentNodes)
	{
		this.posHide(contentNodes);
		this.contentBody = contentNodes;
		this.reviewExtracted = true;
		this.extractContentCallback();
	}

	/******************************************************/
	/******************** Toogle view *********************/
	/******************************************************/
	this.toggleViewCallback = null;

	this.toggleView = function(callback)
	{
		this.toggleViewCallback = callback;

		if (!this.reviewExtracted)
		{
			this.toggleViewCallback();
			return;
		}

		this.toggleTheView();
	}
	this.toggleTheView = function()
	{
		if (!this.showingContent){
			this.document.body = this.contentBody;
		}
		else
			this.document.body = this.originalBody;
		this.finishToggleView();
	}
	this.finishToggleView = function()
	{
		this.showingContent = this.document.body == this.contentBody;
		this.toggleViewCallback();
	}

	/******************************************************/
	/*********************** Others ***********************/
	/******************************************************/ 
	this.hideNotContentNodes = function(contentBody, contentNodes)
	{
		var contentNode;
		var treeSearch = new RevEx.util.TreeSearch(contentBody, new Array());

		while ((contentNode = treeSearch.nextPreOrder()) != null)
			if (!RevEx.misc.Misc.arrayContains(contentNodes, contentNode))
				this.hideNode(contentNode);
	}

	this.posHide = function(node)
	{
		if ((node.final)){
			//node.style.border = "3px solid yellow";
			while ((node) || (node.parentNode.tagName !== "BODY")){
				var noTocar = node.cloneNode(true);
				if (node.parentNode)
					node = node.parentNode;
				else
					break;
				var children = node.childNodes;
				for (var i = 0; i < children.length; i++){
					if (children[i].innerHTML !== noTocar.innerHTML){
						this.hideNode(children[i]);
					}
				}
			}
			return 0;
		}

		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.posHide(children[i]);
			}
		}		
	}	
	
	this.hideNode = function(node)
	{
		node.isHidden = true;

		if (node.style)
		{
			node.style.visibility = "hidden";
			return;
		}

		var nodeName = node.nodeName.toLowerCase();
		if (nodeName == "#text")
			node.nodeValue = "";
	}

}
